#include "bin_gradient.h"

BinarizationGradient::BinarizationGradient(PNM* img) :
    Transformation(img)
{
}

BinarizationGradient::BinarizationGradient(PNM* img, ImageViewer* iv) :
    Transformation(img, iv)
{
}

PNM* BinarizationGradient::transform()
{
    int width = image->width();
    int height = image->height();

    PNM* newImage = new PNM(width, height, QImage::Format_RGB32);

    float a = 0;
    float b = 0;


    for (int x = 0; x<width; x++)
    for (int y = 0; y<height; y++){
        int Gx = qGray(getPixel(x + 1, y, RepeatEdge)) - qGray(getPixel(x - 1, y, RepeatEdge));
        int Gy = qGray(getPixel(x, y + 1, RepeatEdge)) - qGray(getPixel(x, y - 1, RepeatEdge));

        a += Gx > Gy ? Gx : Gy * qGray(getPixel(x, y, RepeatEdge));
        b += Gx > Gy ? Gx : Gy;

    }

    int threshold = a / b;

    for (int x = 0; x<width; x++)
        for (int y = 0; y<height; y++) {
            QRgb pixel = image->pixel(x,y);

            int v = 0;
            if (qGray(pixel) >= threshold) v = 255;

            newImage->setPixel(x,y, QColor(v,v,v).rgb());
        }

    return newImage;
}


