#include "blur_linear.h"

BlurLinear::BlurLinear(PNM* img) :
    Convolution(img)
{
}

BlurLinear::BlurLinear(PNM* img, ImageViewer* iv) :
    Convolution(img, iv)
{
}

PNM* BlurLinear::transform()
{
    int maskSize = getParameter("size").toInt();
    QList<QVariant> tmpMask = getParameter("mask").toList();
    bool normalize = getParameter("normalize").toBool();

    math::matrix<float> mask(maskSize, maskSize);

    double maskSum = 0.0;
    if (normalize) {
        for (int i=0;i<tmpMask.size();++i) {
            maskSum += tmpMask.at(i).toDouble();
        }
    }

    for (int x=0;x<maskSize;++x) {
        for (int y=0;y<maskSize;++y) {
            double val = tmpMask.at((y * maskSize) + x).toDouble();
            if (normalize && maskSum != 0.0) {
                val /= maskSum;
            }
            mask[x][y] = val;
        }
    }

    return convolute(mask, RepeatEdge);
}
