#include "conversion_grayscale.h"

ConversionGrayscale::ConversionGrayscale(PNM* img) :
    Transformation(img)
{
}

ConversionGrayscale::ConversionGrayscale(PNM* img, ImageViewer* iv) :
    Transformation(img, iv)
{
}

PNM* ConversionGrayscale::transform()
{
    qDebug() << Q_FUNC_INFO << image->format();

    int width = image->width();
    int height = image->height();

    PNM* newImage = new PNM(width, height, QImage::Format_Grayscale8);

    if (image->format() == QImage::Format_Mono)
    {
        qDebug() << Q_FUNC_INFO << "Gray";
        for (int x=0; x<width; x++)
            for (int y=0; y<height; y++)
            {


                QColor color = QColor::fromRgb(image->pixel(x,y)); // Getting the pixel(x,y) value
                newImage->setPixel(x,y, color == Qt::white ? Qt::color0 : Qt::color1);
            }
    }
    else // if (image->format() == QImage::Format_RGB32)
    {
        qDebug() << Q_FUNC_INFO << "color!";
            for (int x=0; x<width; x++)
                for (int y=0; y<height; y++)
                {
                    QRgb pixel = image->pixel(x,y);
    
                    int red = qRed(pixel);
                    int green = qGreen(pixel);
                    int blue = qBlue(pixel);
    
                    int v = (red * 0.3) +(green * 0.6) +(blue * 0.1);
    
                    newImage->setPixel(x,y, QColor(v,v,v).rgb());
                }
        }
qDebug() << Q_FUNC_INFO << newImage->format();
    return newImage;
}
