#include "edge_gradient.h"

EdgeGradient::EdgeGradient(PNM* img, ImageViewer* iv) :
    Convolution(img, iv)
{
}

EdgeGradient::EdgeGradient(PNM* img) :
    Convolution(img)
{
}

PNM* EdgeGradient::verticalDetection()
{
    return convolute(g_y, RepeatEdge);
}

PNM* EdgeGradient::horizontalDetection()
{
    return convolute(g_x, RepeatEdge);
}

PNM* EdgeGradient::transform()
{
    PNM* newImage = new PNM(image->width(), image->height(), image->format());

        PNM* horizontal = horizontalDetection();
        PNM* vertical = verticalDetection();

        for (int x=0;x<image->width();++x) {
            for (int y=0;y<image->height();++y) {

                int hp = horizontal->pixel(x,y);
                int vp = vertical->pixel(x,y);

                int r = sqrt(pow(qRed(hp), 2.0) + pow(qRed(vp), 2.0));
                int g = sqrt(pow(qGreen(hp), 2.0) + pow(qGreen(vp), 2.0));
                int b = sqrt(pow(qBlue(hp), 2.0) + pow(qBlue(vp), 2.0));
                if (r < 0) r = 0;
                if (r > 255) r = 255;
                if (g < 0) r = 0;
                if (g > 255) r = 255;
                if (b < 0) r = 0;
                if (b > 255) r = 255;


                newImage->setPixel(x, y, QColor(r,g,b).rgb());
            }
        }

        return newImage;
}

