#include "edge_roberts.h"

EdgeRoberts::EdgeRoberts(PNM* img) :
    EdgeGradient(img)
{
    prepareMatrices();
}

EdgeRoberts::EdgeRoberts(PNM* img, ImageViewer* iv) :
    EdgeGradient(img, iv)
{
    prepareMatrices();
}

void EdgeRoberts::prepareMatrices()
{
    float array_x[4] = {0, -1, 1, 0};

    float array_y[4] = {-1, 0, 0, 1};

    g_x = math::matrix<float>(2,2, array_x);
    g_y = math::matrix<float>(2,2, array_y);
}
